#include <stdio.h>
#include <unistd.h>
#include <stdlib.h>
#include <fcntl.h>
#include <sys/ioctl.h>
#include <linux/soundcard.h>
#include <errno.h>
#include <string.h>

#define EMPEG_MIXER_READ_FLAGS _IOR('m', 1, int)
#define EMPEG_MIXER_WRITE_FLAGS _IOW('m', 1, int)
#define EMPEG_MIXER_FLAG_MUTE (1<<0)

int main(int ac, char *av[])
{
    int mute = -1;
    int flags = 0;
    int fd = -1;
    
    while (*++av)
    {
	if(av[0][0] == '-')
	{
	    switch(av[0][1])
	    {
	    case 'm':
		mute = 1;
		break;
	    case 'u':
		mute = 0;
		break;
	    default:
		fprintf(stderr, "Usage: mute [-u|-m]\n");
		return 1;
	    }
	}
	else
	{
	    fprintf(stderr, "Usage: mute [-u|-m]\n");
	    return 1;
	}
    }

    fd = open("/dev/mixer", O_RDONLY);
    if (fd < 0)
    {
	fprintf(stderr, "Couldn't open /dev/mixer\n");
	return 2;
    }

    if (mute >= 0)
    {
	if (mute)
	    flags |= EMPEG_MIXER_FLAG_MUTE;
	if (ioctl(fd, EMPEG_MIXER_WRITE_FLAGS, &flags) < 0)
	    printf("Write mute ioctl failed: %s (%d)\n", strerror(errno), errno);
    }

    if (ioctl(fd, EMPEG_MIXER_READ_FLAGS, &flags) < 0)
	printf("Read mute ioctl failed: %s (%d)\n", strerror(errno), errno);
		

    if (flags & EMPEG_MIXER_FLAG_MUTE)
	printf("Output is currently muted.\n");
    else
	printf("Output is currently unmuted.\n");

    return 0;
}
